You cannot select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
depot_tools/update_depot_tools

189 lines
5.4 KiB
Plaintext

#!/usr/bin/env bash
# Copyright (c) 2012 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.
# This script will try to sync the bootstrap directories and then defer control.
if [ "$USER" == "root" ];
then
echo Running depot tools as root is sad.
exit
fi
# Test if this script is running under a MSYS install. This is likely an error
# if it is, so we warn the user accordingly.
OUTPUT="$(uname | grep 'MSYS')"
MSYS=$?
if [ $MSYS = 0 ]; then
echo 'WARNING: It looks like you are running these tools from an MSYS shell'
echo '(as opposed to a MinGW shell). This shell is not supported and may'
echo 'fail in mysterious ways.'
echo
echo 'To run the supported MinGW shell, use `git bash`, or use `bin/bash.exe`'
echo 'in your MinGW installation, as opposed to `usr/bin/bash.exe`.'
echo
fi
# Test if this script is running under a MinGW install. If it is, we will
# hardcode the paths to SVN and Git where possible.
OUTPUT="$(uname | grep 'MINGW')"
MINGW=$?
if [ $MINGW = 0 ]; then
base_dir="${0%/*}"
else
base_dir=$(dirname "$0")
if [ -L "$base_dir" ]; then
base_dir=`cd "$base_dir" && pwd -P`
fi
fi
# We want to update the bundled tools even under MinGW.
if [ $MINGW = 0 ]; then
$COMSPEC /c `cygpath -w "$base_dir/bootstrap/win/win_tools.bat"`
case $? in
123)
# msys environment was upgraded, need to quit.
exit 123
;;
0)
;;
*)
exit $?
esac
fi
CANONICAL_GIT_URL="https://chromium.googlesource.com/chromium/tools/depot_tools.git"
SVN="svn"
if [ -d "$base_dir/svn_bin" -a $MINGW = 0 ]; then
SVN="$base_dir/svn_bin/svn.exe"
fi
GIT="git"
if [ -e "$base_dir/git.bat" -a $MINGW = 0 ]; then
GIT="cmd.exe //c \"$base_dir\\git.bat\""
fi
# Test git and git --version.
function test_git {
local GITV
GITV="$(eval "$GIT" --version)" || {
echo "git isn't installed, please install it"
exit 1
}
GITV="${GITV##* }" # Only examine last word (i.e. version number)
local GITD=( ${GITV//./ } ) # Split version number into decimals
if ((GITD[0] < 1 || (GITD[0] == 1 && GITD[1] < 6) )); then
echo "git version is ${GITV}, please update to a version later than 1.6"
exit 1
fi
}
# Test git svn and git svn --version.
function test_git_svn {
local GITV
GITV="$(eval "$GIT" svn --version)" || {
echo "git-svn isn't installed, please install it"
exit 1
}
GITV="${GITV#* version }" # git svn --version has extra output to remove.
GITV="${GITV% (svn*}"
local GITD=( ${GITV//./ } ) # Split version number into decimals
if ((GITD[0] < 1 || (GITD[0] == 1 && GITD[1] < 6) )); then
echo "git version is ${GITV}, please update to a version later than 1.6"
exit 1
fi
}
Handle updating depot_tools repos that are git cloned. Until recently, no proper Git clone of depot_tools existed. All Git clones were set up locally via git svn clone. The way repos of that type are updated is via 'git svn rebase'. Now, a supported Git clone of depot_tools exists. The update process for repos of this type is via 'git fetch' and 'git rebase'. Modify the update_depot_tools* scripts so they can update depot_tools for git cloned or git svn cloned methods. This also means that git svn is no longer required, so move that test after we check for git cloned repos. R=maruel@chromium.org TEST=Linux + git clone: on Linux, git clone https://git.chromium.org/chromium/tools/depot_tools.git. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Linux + git svn clone: on Linux, git svn clone svn://svn.chromium.org/chrome/trunk/tools/depot_tools. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git clone: on Windows command prompt, run Linux+git clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git svn clone: on Windows command prompt, run Linux+git svn clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git clone: on Windows command prompt, run Linux+git clone test. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git svn clone: on Windows command prompt, run Linux+git svn clone test. Verify depot_tools is updated to latest available revision + this change. Review URL: https://chromiumcodereview.appspot.com/10263004 git-svn-id: svn://svn.chromium.org/chrome/trunk/tools/depot_tools@134732 0039d316-1c4b-4281-b951-d872f2087c98
13 years ago
function is_git_clone_repo {
eval "$GIT" config remote.origin.fetch > /dev/null
Handle updating depot_tools repos that are git cloned. Until recently, no proper Git clone of depot_tools existed. All Git clones were set up locally via git svn clone. The way repos of that type are updated is via 'git svn rebase'. Now, a supported Git clone of depot_tools exists. The update process for repos of this type is via 'git fetch' and 'git rebase'. Modify the update_depot_tools* scripts so they can update depot_tools for git cloned or git svn cloned methods. This also means that git svn is no longer required, so move that test after we check for git cloned repos. R=maruel@chromium.org TEST=Linux + git clone: on Linux, git clone https://git.chromium.org/chromium/tools/depot_tools.git. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Linux + git svn clone: on Linux, git svn clone svn://svn.chromium.org/chrome/trunk/tools/depot_tools. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git clone: on Windows command prompt, run Linux+git clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git svn clone: on Windows command prompt, run Linux+git svn clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git clone: on Windows command prompt, run Linux+git clone test. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git svn clone: on Windows command prompt, run Linux+git svn clone test. Verify depot_tools is updated to latest available revision + this change. Review URL: https://chromiumcodereview.appspot.com/10263004 git-svn-id: svn://svn.chromium.org/chrome/trunk/tools/depot_tools@134732 0039d316-1c4b-4281-b951-d872f2087c98
13 years ago
}
function update_git_repo {
remote_url=$(eval "$GIT" config --get remote.origin.url)
if [ -n "$remote_url" -a "$remote_url" != "$CANONICAL_GIT_URL" ]; then
echo "Your copy of depot_tools is configured to fetch from an obsolete URL:"
echo
echo " $remote_url"
echo
read -t 60 -p "OK to update it to $CANONICAL_GIT_URL ? [Y/n] " -n 1
STATUS=$?
echo
if [[ $STATUS -ne 0 ]]; then
echo "Timeout; not updating remote URL."
elif [ -z "$REPLY" -o "$REPLY" = "Y" -o "$REPLY" = "y" ]; then
eval "$GIT" config remote.origin.url "$CANONICAL_GIT_URL"
echo "Remote URL updated."
fi
fi
Handle updating depot_tools repos that are git cloned. Until recently, no proper Git clone of depot_tools existed. All Git clones were set up locally via git svn clone. The way repos of that type are updated is via 'git svn rebase'. Now, a supported Git clone of depot_tools exists. The update process for repos of this type is via 'git fetch' and 'git rebase'. Modify the update_depot_tools* scripts so they can update depot_tools for git cloned or git svn cloned methods. This also means that git svn is no longer required, so move that test after we check for git cloned repos. R=maruel@chromium.org TEST=Linux + git clone: on Linux, git clone https://git.chromium.org/chromium/tools/depot_tools.git. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Linux + git svn clone: on Linux, git svn clone svn://svn.chromium.org/chrome/trunk/tools/depot_tools. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git clone: on Windows command prompt, run Linux+git clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git svn clone: on Windows command prompt, run Linux+git svn clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git clone: on Windows command prompt, run Linux+git clone test. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git svn clone: on Windows command prompt, run Linux+git svn clone test. Verify depot_tools is updated to latest available revision + this change. Review URL: https://chromiumcodereview.appspot.com/10263004 git-svn-id: svn://svn.chromium.org/chrome/trunk/tools/depot_tools@134732 0039d316-1c4b-4281-b951-d872f2087c98
13 years ago
if is_git_clone_repo; then
git fetch -q origin &> /dev/null
local REBASE_TXT STATUS
REBASE_TXT=$(git rebase -q origin/master 2>&1)
STATUS=$?
if [[ $STATUS -ne 0 ]]; then
echo "depot_tools update failed. Conflict in $base_dir" >&2
echo "$REBASE_TXT" >&2
git rebase --abort 2> /dev/null
fi
return $STATUS
Handle updating depot_tools repos that are git cloned. Until recently, no proper Git clone of depot_tools existed. All Git clones were set up locally via git svn clone. The way repos of that type are updated is via 'git svn rebase'. Now, a supported Git clone of depot_tools exists. The update process for repos of this type is via 'git fetch' and 'git rebase'. Modify the update_depot_tools* scripts so they can update depot_tools for git cloned or git svn cloned methods. This also means that git svn is no longer required, so move that test after we check for git cloned repos. R=maruel@chromium.org TEST=Linux + git clone: on Linux, git clone https://git.chromium.org/chromium/tools/depot_tools.git. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Linux + git svn clone: on Linux, git svn clone svn://svn.chromium.org/chrome/trunk/tools/depot_tools. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git clone: on Windows command prompt, run Linux+git clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git svn clone: on Windows command prompt, run Linux+git svn clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git clone: on Windows command prompt, run Linux+git clone test. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git svn clone: on Windows command prompt, run Linux+git svn clone test. Verify depot_tools is updated to latest available revision + this change. Review URL: https://chromiumcodereview.appspot.com/10263004 git-svn-id: svn://svn.chromium.org/chrome/trunk/tools/depot_tools@134732 0039d316-1c4b-4281-b951-d872f2087c98
13 years ago
fi
test_git_svn
# work around a git-svn --quiet bug
OUTPUT=`eval "$GIT" svn rebase -q -q`
Handle updating depot_tools repos that are git cloned. Until recently, no proper Git clone of depot_tools existed. All Git clones were set up locally via git svn clone. The way repos of that type are updated is via 'git svn rebase'. Now, a supported Git clone of depot_tools exists. The update process for repos of this type is via 'git fetch' and 'git rebase'. Modify the update_depot_tools* scripts so they can update depot_tools for git cloned or git svn cloned methods. This also means that git svn is no longer required, so move that test after we check for git cloned repos. R=maruel@chromium.org TEST=Linux + git clone: on Linux, git clone https://git.chromium.org/chromium/tools/depot_tools.git. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Linux + git svn clone: on Linux, git svn clone svn://svn.chromium.org/chrome/trunk/tools/depot_tools. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git clone: on Windows command prompt, run Linux+git clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git svn clone: on Windows command prompt, run Linux+git svn clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git clone: on Windows command prompt, run Linux+git clone test. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git svn clone: on Windows command prompt, run Linux+git svn clone test. Verify depot_tools is updated to latest available revision + this change. Review URL: https://chromiumcodereview.appspot.com/10263004 git-svn-id: svn://svn.chromium.org/chrome/trunk/tools/depot_tools@134732 0039d316-1c4b-4281-b951-d872f2087c98
13 years ago
if [[ ! "$OUTPUT" == *Current.branch* ]]; then
echo $OUTPUT 1>&2
fi
return 0
}
# Get the current SVN revision.
get_svn_revision() {
LANGUAGE=C "$SVN" info "$base_dir" | \
awk -F': ' '{ if ($1 == "Last Changed Rev") { print $2 }}'
}
# Update git checkouts.
if [ "X$DEPOT_TOOLS_UPDATE" != "X0" -a -e "$base_dir/.git" ]
then
cd $base_dir
Handle updating depot_tools repos that are git cloned. Until recently, no proper Git clone of depot_tools existed. All Git clones were set up locally via git svn clone. The way repos of that type are updated is via 'git svn rebase'. Now, a supported Git clone of depot_tools exists. The update process for repos of this type is via 'git fetch' and 'git rebase'. Modify the update_depot_tools* scripts so they can update depot_tools for git cloned or git svn cloned methods. This also means that git svn is no longer required, so move that test after we check for git cloned repos. R=maruel@chromium.org TEST=Linux + git clone: on Linux, git clone https://git.chromium.org/chromium/tools/depot_tools.git. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Linux + git svn clone: on Linux, git svn clone svn://svn.chromium.org/chrome/trunk/tools/depot_tools. Apply and commit this patch locally. Note commit hash of HEAD. Run 'git reset --hard "HEAD^^^"'. Run 'git cherry-pick HASH_OF_UPDATE_CHANGE'. Run './update_depot_tools'. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git clone: on Windows command prompt, run Linux+git clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows command prompt + git svn clone: on Windows command prompt, run Linux+git svn clone test, except use update_depot_tools.bat. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git clone: on Windows command prompt, run Linux+git clone test. Verify depot_tools is updated to latest available revision + this change. TEST=Windows cygwin + git svn clone: on Windows command prompt, run Linux+git svn clone test. Verify depot_tools is updated to latest available revision + this change. Review URL: https://chromiumcodereview.appspot.com/10263004 git-svn-id: svn://svn.chromium.org/chrome/trunk/tools/depot_tools@134732 0039d316-1c4b-4281-b951-d872f2087c98
13 years ago
update_git_repo
cd - > /dev/null
fi
# We're on POSIX. We can now safely look for svn checkout.
if [ "X$DEPOT_TOOLS_UPDATE" != "X0" -a -e "$base_dir/.svn" ]
then
echo "========================"
echo "WARNING: You have an SVN checkout of depot_tools!"
echo
echo "depot_tools is migrating to Git on June 6, 2016. If you still have an"
echo "SVN checkout then, you will STOP RECEIVING UPDATES to depot_tools."
echo
echo "Before that date, please follow the instructions here[1] to get a Git"
echo "copy of depot_tools."
echo
echo "[1]: https://www.chromium.org/developers/how-tos/install-depot-tools"
echo "========================"
# Update the root directory to stay up-to-date with the latest depot_tools.
BEFORE_REVISION=$(get_svn_revision)
if echo $* | grep -e --force > /dev/null; then
"$SVN" -q revert -R "$base_dir"
fi
"$SVN" -q up "$base_dir"
AFTER_REVISION=$(get_svn_revision)
if [[ "$BEFORE_REVISION" != "$AFTER_REVISION" ]]; then
if [ -z "$DEPOT_TOOLS_HIDE_UPDATED_MESSAGE" ]; then
echo "Depot Tools has been updated to revision $AFTER_REVISION." 1>&2
fi
fi
fi
find "$base_dir" -iname "*.pyc" -exec rm -f {} \;